/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2010  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
using System;
using Db4oUnit;
using Db4objects.Db4o.Config;
using Db4objects.Db4o.Config.Encoding;
using Db4objects.Db4o.Internal.Encoding;
using Db4objects.Db4o.Tests.Common.Config;

namespace Db4objects.Db4o.Tests.Common.Config
{
	public class UTF8StringEncodingTestCase : StringEncodingTestCaseBase
	{
		/// <exception cref="System.Exception"></exception>
		protected override void Configure(IConfiguration config)
		{
			config.StringEncoding(StringEncodings.Utf8());
		}

		protected override Type StringIoClass()
		{
			return typeof(DelegatingStringIO);
		}

		public static void Main(string[] arguments)
		{
			new UTF8StringEncodingTestCase().RunEmbedded();
		}

		public virtual void TestEncodeDecode()
		{
			string original = "ABCZabcz?$@#.,;:";
			UTF8StringEncoding encoder = new UTF8StringEncoding();
			byte[] bytes = encoder.Encode(original);
			string decoded = encoder.Decode(bytes, 0, bytes.Length);
			Assert.AreEqual(original, decoded);
		}
	}
}
