/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2010  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
using System;
using Db4oUnit;
using Db4oUnit.Extensions;
using Db4objects.Db4o.Config;
using Db4objects.Db4o.Tests.Common.Exceptions;

namespace Db4objects.Db4o.Tests.Common.Exceptions
{
	public class GlobalOnlyConfigExceptionTestCase : AbstractDb4oTestCase
	{
		public static void Main(string[] args)
		{
			new GlobalOnlyConfigExceptionTestCase().RunAll();
		}

		public virtual void TestBlockSize()
		{
			Assert.Expect(typeof(ArgumentException), new _ICodeBlock_16(this));
			Assert.Expect(typeof(ArgumentException), new _ICodeBlock_22(this));
			Assert.Expect(typeof(GlobalOnlyConfigException), new _ICodeBlock_28(this));
		}

		private sealed class _ICodeBlock_16 : ICodeBlock
		{
			public _ICodeBlock_16(GlobalOnlyConfigExceptionTestCase _enclosing)
			{
				this._enclosing = _enclosing;
			}

			/// <exception cref="System.Exception"></exception>
			public void Run()
			{
				this._enclosing.Db().Configure().BlockSize(-1);
			}

			private readonly GlobalOnlyConfigExceptionTestCase _enclosing;
		}

		private sealed class _ICodeBlock_22 : ICodeBlock
		{
			public _ICodeBlock_22(GlobalOnlyConfigExceptionTestCase _enclosing)
			{
				this._enclosing = _enclosing;
			}

			/// <exception cref="System.Exception"></exception>
			public void Run()
			{
				this._enclosing.Db().Configure().BlockSize(128);
			}

			private readonly GlobalOnlyConfigExceptionTestCase _enclosing;
		}

		private sealed class _ICodeBlock_28 : ICodeBlock
		{
			public _ICodeBlock_28(GlobalOnlyConfigExceptionTestCase _enclosing)
			{
				this._enclosing = _enclosing;
			}

			/// <exception cref="System.Exception"></exception>
			public void Run()
			{
				this._enclosing.Db().Configure().BlockSize(12);
			}

			private readonly GlobalOnlyConfigExceptionTestCase _enclosing;
		}
	}
}
